unit Options;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, TabNotBk;

type
  TfrmOptions = class(TForm)
    bbnOK: TBitBtn;
    GroupBox1: TGroupBox;
    chkWipeCipher: TCheckBox;
    grpEncryptOptions: TGroupBox;
    chkASCIIOut: TCheckBox;
    chkSign: TCheckBox;
    GroupBox2: TGroupBox;
    chkFileHistory: TCheckBox;
    chkRecoverFilename: TCheckBox;
    chkExpertMode: TCheckBox;
    lblPGPExePath: TLabel;
    edtPGPExePath: TEdit;
    chkPGPWipeSource: TCheckBox;
    chkConvWipeSource: TCheckBox;
    Label1: TLabel;
    edtTimeZone: TEdit;
    Label2: TLabel;
    edtTempPath: TEdit;
    procedure FormShow(Sender: TObject);
    procedure bbnOKClick(Sender: TObject);
    procedure chkExpertModeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmOptions: TfrmOptions;

implementation

{$R *.DFM}

uses
     Main, Decl;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
     {get the options}
     chkASCIIOut.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_ASCII_OUT,LIT_NO) = LIT_YES);
     chkPGPWipeSource.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_PGPWIPESOURCE,LIT_NO) = LIT_YES);
     chkConvWipeSource.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_CONVWIPESOURCE,LIT_NO) = LIT_YES);
     chkSign.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_SIGN,LIT_NO) = LIT_YES);
     chkRecoverFilename.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_RECOVER,LIT_NO) = LIT_YES);
     chkWipeCipher.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_CONVWIPECIPHER,LIT_NO) = LIT_YES);
     chkFileHistory.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_HISTORY,LIT_NO) = LIT_YES);
     chkExpertMode.Checked := (WinPGPIni.ReadString(LIT_OPTIONS,LIT_EXPERT,LIT_NO) = LIT_YES);
     edtPGPExePath.Text := WinPGPIni.ReadString(LIT_OPTIONS,LIT_PGPPATH,'');
     edtTimeZone.Text := WinPGPIni.ReadString(LIT_OPTIONS,LIT_TIMEZONE,'');
     edtTempPath.Text := WinPGPIni.ReadString(LIT_OPTIONS,LIT_TEMPPATH,'');
end;

procedure TfrmOptions.bbnOKClick(Sender: TObject);
begin
     {check that the options make sense}
     if FileExists(edtPGPExePath.Text + '\' + LIT_PGP_EXE) then
     begin
          {Save the options Back}
          WriteIniOption(LIT_ASCII_OUT, chkASCIIOut.Checked);
          WriteIniOption(LIT_PGPWIPESOURCE, chkPGPWipeSource.Checked);
          WriteIniOption(LIT_CONVWIPESOURCE, chkConvWipeSource.Checked);
          WriteIniOption(LIT_SIGN, chkSign.Checked);
          WriteIniOption(LIT_RECOVER, chkRecoverFilename.Checked);
          WriteIniOption(LIT_CONVWIPECIPHER, chkWipeCipher.Checked);
          WriteIniOption(LIT_HISTORY, chkFileHistory.Checked);
          WriteIniOption(LIT_EXPERT, chkExpertMode.Checked);
          WinPGPIni.WriteString(LIT_OPTIONS,LIT_PGPPATH,edtPGPExePath.Text);
          WinPGPIni.WriteString(LIT_OPTIONS,LIT_TEMPPATH,edtTempPath.Text);
          WinPGPIni.WriteString(LIT_OPTIONS,LIT_TIMEZONE,edtTimeZone.Text);
          Close;
     end
     else
     begin
          if MessageDlg(LIT_MSG14,mtWarning,[mbRetry,mbAbort],2) = mrAbort then
          begin
               Halt;
          end
          else
          begin
               edtPGPExePath.SetFocus;
          end;
     end;
end;

procedure TfrmOptions.chkExpertModeClick(Sender: TObject);
begin
     {Set options according to mode - expert mode has extra options}
     frmWinPGP.mnpAddKeyS.Visible := chkExpertMode.Checked;
     frmWinPGP.mnpCopyKeyS.Visible := chkExpertMode.Checked;
end;

procedure TfrmOptions.FormCreate(Sender: TObject);
var
     EnvParam: string;
begin
     if GetEnvironmentVariable('tz', EnvParam) then
     begin
          edtTimeZone.Text := EnvParam;
          edtTimeZone.Enabled := False;
     end
     else
     begin
          edtTimeZone.Enabled := True;
     end;

     if GetEnvironmentVariable('temp', EnvParam) then
     begin
          edtTempPath.Text := EnvParam;
          edtTempPath.Enabled := False;
     end
     else
     begin
          edtTempPath.Enabled := True;
     end;

     if GetEnvironmentVariable('pgppath', EnvParam) then
     begin
          edtPGPExePath.Text := EnvParam;
          edtPGPExePath.Enabled := False;
     end
     else
     begin
          edtPGPExePath.Enabled := True;
     end;

end;

end.
